/*
 * tut8.c -- SDL-Tutorial, 8. Kapitel
 * NO Copyright (c) by Nicolai 'Prefect' Haehnle
 *
 * Diese Software ist Public Domain.
 */

#include <stdlib.h>
#include <stdio.h>

#include <SDL.h>
#include <SDL_opengl.h>

/*
Die Funktion RefreshScreen ist fr die eigentliche Darstellung auf dem
Bildschirm verantwortlich
*/
void RefreshScreen()
{
/* Lsche den Bildschirm mit schwarzer Farbe */
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glClear(GL_COLOR_BUFFER_BIT);

/* Zeichne ein Rechteck mit Farbverlufen */
	glBegin(GL_QUADS);
		glColor3ub(255, 0, 0);		glVertex2i(0, 240);
		glColor3ub(0, 255, 0);		glVertex2i(240, 240);
		glColor3ub(0, 0, 255);		glVertex2i(240, 480);
		glColor3ub(255, 255, 0);	glVertex2i(0, 480);
	glEnd();
}

int main(int argc, char **argv)
{
	SDL_Surface *screen;
	int running;

	if (SDL_Init(SDL_INIT_VIDEO) < 0) {
		fprintf(stderr, "SDL konnte nicht initialisiert werden: %s\n",
			SDL_GetError());
		exit(1);
	}
	atexit(SDL_Quit);

/* OpenGL-Bildschirmmodus */
	SDL_GL_SetAttribute(SDL_GL_RED_SIZE, 5);
	SDL_GL_SetAttribute(SDL_GL_GREEN_SIZE, 5);
	SDL_GL_SetAttribute(SDL_GL_BLUE_SIZE, 5);
	SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 16);
	SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);

	screen = SDL_SetVideoMode(640, 480, 0, SDL_OPENGL);
	if (!screen) {
		fprintf(stderr, "Konnte Bildschirmmodus nicht setzen: %s\n",
			SDL_GetError());
		exit(1);
	}

/* Initialisiere OpenGL-Status */
	glViewport(0, 0, screen->w, screen->h);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0, screen->w, screen->h, 0, -1.0, 1.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

/* Programmschleife */
	running = 1;
	while(running) {
		SDL_Event event;

		while(SDL_PollEvent(&event)) {
			switch(event.type) {
			case SDL_KEYDOWN:
				running = 0;
				break;
			case SDL_QUIT:
				running = 0;
				break;
			}
		}

		RefreshScreen();

		// Pageflip: Back- und Frontbuffer werden vertauscht
		SDL_GL_SwapBuffers();
	}

        return 0;
}
